import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface HttpProviderConfig {
    /**
    * Alias name
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/http#alias HttpProvider#alias}
    */
    readonly alias?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/http http}
*/
export declare class HttpProvider extends cdktf.TerraformProvider {
    static readonly tfResourceType = "http";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/http http} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options HttpProviderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: HttpProviderConfig);
    private _alias?;
    get alias(): string | undefined;
    set alias(value: string | undefined);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
